NEW BOARD: Dell Precision T1650

Very nice ivybridge board that supports ECC RAM.
NOTE: I couldn't get onboard graphics working yet, but
this was confirmed working with a graphics card (in my
case nvidia quadra k420) booted in text mode on the SeaBIOS
payload. The GRUB payload also works, when loaded from SeaBIOS.
Therefore, this is a SeaBIOS-only board (as far as first payload
is concerned), but you can pick GRUB from the menu.

You could make it "GRUB-only" in practise by setting SeaBIOS
boot order to only load GRUB, and disable the SeaBIOS menu.
We refer to this as "SeaGRUB".

I've made lbmk use biosutilities and uefiextract, to
get at the SMSC SCH5545 Environmental Control (EC) firmware.
This firmware is needed for fan control. This is automatically
downloaded and extracted, from Dell UEFI firmware updates.

As with other blobs such as Intel ME, this firmware is then
scrubbed by the release build scripts. The blobutil "inject"
script can be used to re-insert it.

Of note: there is no fixed offset, but no other blobs to
be inserted in CBFS either, so the offset when re-inserting
on release ROMs should still be the same, and thus the ROM
checksums should match, when running blobutil inject.

Signed-off-by: Leah Rowe <leah@libreboot.org>
This commit is contained in:
Leah Rowe
2023-08-11 14:50:17 +01:00
parent f8f77cb288
commit f9afeb6feb
21 changed files with 937 additions and 6 deletions
+28
View File
@@ -0,0 +1,28 @@
#!/usr/bin/env sh
# helper script: run make clean on bios_extract
#
# Copyright (C) 2023 Leah Rowe <info@minifree.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
[ "x${DEBUG+set}" = 'xset' ] && set -v
set -u -e
printf "Cleaning the previous build of uefitool (UEFIExtract)\n"
[ ! -d "uefitool" ] && exit 0
make clean -BC uefitool || exit 1
@@ -94,6 +94,11 @@ pacman -S --needed --noconfirm libpciaccess pciutils zlib libftdi \
pacman -S --needed --noconfirm innoextract p7zip unar
# UEFIExtract
# ------------
pacman -S --needed --noconfirm cmake
# U-Boot build dependencies
# ------------------------------------------------------------
pacman -S --needed --noconfirm swig dtc
@@ -127,6 +127,10 @@ apt-get -y install libpci-dev pciutils zlib1g-dev libftdi-dev \
# For cross-compiling i686 target on x86_64 host.
[ "${arch}" -eq 0 ] && apt-get -y install lib32z1-dev
# UEFIExtract
# ------------
apt-get -y install cmake
# Blobs building dependencies (for me)
# ------------------------------------------------------------
@@ -93,6 +93,11 @@ dnf -y install gcc
dnf -y install pciutils-devel zlib-devel libftdi-devel gcc libusb-devel
# UEFIExtract
# ------------
dnf -y install cmake
# For extracting IntelME from lenovo updates (X230 etc)
dnf -y install innoextract p7zip p7zip-plugins unar
@@ -101,6 +101,11 @@ pacman -S --needed --noconfirm innoextract p7zip unar
# ------------------------------------------------------------
pacman -S --needed --noconfirm swig dtc
# UEFIExtract
# ------------
pacman -S --needed --noconfirm cmake
# Unifont, for GRUB
# ------------------------------------------------------------
@@ -109,6 +109,10 @@ apt-get -y install libpci-dev pciutils zlib1g-dev libftdi-dev \
# For cross-compiling i686 target on x86_64 host.
[ "${arch}" -eq 0 ] && apt-get -y install lib32z1-dev
# UEFIExtract
# ------------
apt-get -y install cmake
# Blobs building dependencies (for me)
# ------------------------------------------------------------
@@ -85,6 +85,11 @@ xbps-install -y base-devel
xbps-install -y libpciaccess pciutils zlib libftdi1 base-devel libusb
# UEFIExtract
# ------------
xbps-install -y cmake
# Management engine extraction dependencies
# ------------------------------------------------------------
+44
View File
@@ -0,0 +1,44 @@
#!/usr/bin/env sh
# helper script: builds bios_extract source code
#
# Copyright (C) 2023 Leah Rowe <info@minifree.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
[ "x${DEBUG+set}" = 'xset' ] && set -v
set -u -e
main()
{
if [ ! -d "uefitool" ]; then
./download uefitool || fail "cannot download uefitool"
fi
printf "Building uefitool (UEFIExtract)\n"
(
cd uefitool || fail "uefitool not downloaded"
cmake UEFIExtract/ || fail "cannot cmake UEFIExtract"
make || fail "error compiling UEFIExtract"
)
}
fail()
{
printf "(uefitool build) %s\n" $1 1>&2
}
main $@
+9
View File
@@ -29,6 +29,7 @@ target=""
CONFIG_HAVE_MRC=""
CONFIG_HAVE_ME_BIN=""
CONFIG_KBC1126_FIRMWARE=""
CONFIG_INCLUDE_SMSC_SCH5545_EC_FW=""
ifdtool="cbutils/${cbtree}/ifdtool"
cbfstool="cbutils/${cbtree}/cbfstool"
@@ -76,6 +77,7 @@ make_archive()
CONFIG_HAVE_MRC="y"
CONFIG_HAVE_ME_BIN="y"
CONFIG_KBC1126_FIRMWARE="y"
CONFIG_INCLUDE_SMSC_SCH5545_EC_FW="y"
grep "CONFIG_HAVE_ME_BIN=y" \
"resources/coreboot/${target}/config/"* \
|| CONFIG_HAVE_ME_BIN="n"
@@ -85,6 +87,9 @@ make_archive()
grep "CONFIG_KBC1126_FIRMWARE=y" \
"resources/coreboot/${target}/config"/* \
|| CONFIG_KBC1126_FIRMWARE="n"
grep "CONFIG_INCLUDE_SMSC_SCH5545_EC_FW=y" \
"resources/coreboot/${target}/config"/* \
|| CONFIG_INCLUDE_SMSC_SCH5545_EC_FW="n"
# remove ME/MRC/EC firmware from ROM images
if [ "${CONFIG_HAVE_ME_BIN}" = "y" ] \
@@ -163,6 +168,10 @@ strip_rom_image()
${cbfstool} "${romfile}" remove -n ecfw2.bin || exit 1
fi
if [ "${CONFIG_INCLUDE_SMSC_SCH5545_EC_FW}" = "y" ]; then
${cbfstool} "${romfile}" remove -n sch5545_ecfw.bin || exit 1
fi
# TODO: replace this board-specific hack
if [ "${target}" = "e6400nvidia_4mb" ]; then
${cbfstool} "${romfile}" remove \
+3 -3
View File
@@ -24,7 +24,7 @@ set -u -e
projectname="$(cat projectname)"
modlist="coreboot flashrom grub memtest86plus seabios me_cleaner u-boot"
modlist="${modlist} bios_extract"
modlist="${modlist} bios_extract biosutilities uefitool"
dirlist="resources util" # do not add blobs directory here. it's handled below
@@ -104,8 +104,8 @@ copy_blobs()
mkdir -p "${srcdir}"/blobs
# do not copy intel ME etc, but do copy ifd/gbe files
for i in t440p xx20 xx30 hp8200sff hp_ivybridge hp_sandybridge \
hp8300usdt; do
for j in ifd gbe 16_ifd; do
hp8300usdt t1650; do
for j in ifd gbe 4_ifd 8_ifd 12_ifd 16_ifd; do
if [ -f "blobs/${i}/${j}.bin" ]; then
if [ ! -e "${srcdir}/blobs/${i}" ]; then
mkdir -p "${srcdir}/blobs/${i}"